var bcrypt  = require('bcrypt-nodejs'),
    fs      = require('fs'),
    _       = require('underscore')

    userFile = '/etc/sputnik-users.conf';
;

module.exports = {
    users:null
    ,getUsers:function(){
          var users = JSON.parse(JSON.stringify(this._getUsers()));
         _.map(users, function(user){ delete user.password; return user; });
         return users;
    }
    ,_getUsers: function(){
        if( !(this.users) ){
            try{
                this.users = JSON.parse(fs.readFileSync(userFile, 'utf8'));
                return this.users;
            }
            catch(e){
                console.log('Failed to read sputnik-users conf file:', e)
            }
        }
        else{
            return this.users;
        }
    }
    // methods ======================
    // generating a hash
    ,generateHash:function(password) {
        return bcrypt.hashSync(password, bcrypt.genSaltSync(8), null);
    }

    // checking if password is valid
    ,validPassword:function(password, hash) {
        try{
            return bcrypt.compareSync(password, hash)
        }
        catch(e){
            console.log(e);
        }
    }
    ,changePassword:function(id, newPassword) {
        var newUsers = JSON.parse(JSON.stringify(this._getUsers()));
        var user = this.findById( id, null, newUsers );
            user.password = this.generateHash(newPassword);

            try{
                fs.writeFileSync(userFile, JSON.stringify(newUsers));
            }
            catch(e){
                console.log(e);
                return false;
            }
            this.users = newUsers;
            return true;

    }
    ,findById:function(id, fn, users) {
     if( !(users) ){
         users = this._getUsers();
     }
      var idx = id - 1;
      if (users[idx]) {
        if( _.isFunction(fn) ){
            fn(null, users[idx]);
        }
        else{
            return users[idx];
        }

      } else {
        if( _.isFunction(fn) ){
            fn(new Error('User ' + id + ' does not exist'));
        }
        else{
            return false;
        }
      }
    }
    ,authenticateUser:function(username, password, fn){
        var user = this.findByUsername(username);
        if( user && this.validPassword(password, user.password)){
            return fn(null, user);
        }
        return fn(null, null);
    }
    ,findByUsername: function(username, users) {
        if( !(users) ){
            users = this._getUsers();
        }
        for (var i = 0, len = users.length; i < len; i++) {
            var user = users[i];
            if (user.username === username) {
              return user;
            }
        }
      return null;
    }
}


