
Application['sputnikConfig'] = (function() {
  var module = {exports: {}};
  var exports = module.exports;
  Application['sputnikConfig'] = exports;

  /* router : sputnikConfig */
module.name = "sputnikConfig";
module.routes = {"sputnikConfig":"index","userManagement":"userManagement"};
new (Backbone.Router.extend({
  routes: module.routes
  ,index: function() {
        var vent = _.extend({}, Backbone.Events); //event aggregator

        var model = new Application.Model({}, {url:'/sputnik/settings'});
        var indexView = new Application.Views["sputnikConfig/index"]({model:model, vent:vent});
            Application.setView(indexView);
   }
   ,userManagement:function(){
        var vent = _.extend({}, Backbone.Events); //event aggregator
        var collection = new Application.Collection([], {url:'/sputnik/users'});
        var indexView = new Application.Views["sputnikConfig/userManagement"]({collection:collection, vent:vent});
            Application.setView(indexView);
   }
}));
;;
Handlebars.templates['sputnikConfig/index'] = Handlebars.compile('{{#model}}\n<div class=\"container\" style=\"max-width:1100px;\">\n\n<div id=\"error-display\" class=\"alert alert-danger\" role=\"alert\" style=\"display:none;\"><span class=\"glyphicon glyphicon-exclamation-sign\"></span>\n    Error: NONE of your settings were applied due to the following errors:\n    <div class=\"erroMsg\"></div>\n</div>\n\n<!-- Nav tabs -->\n<ul class=\"nav nav-tabs\">\n  <li class=\"active\"><a href=\"#network\" data-toggle=\"tab\">Server</a></li>\n  <li><a href=\"#stream-monitor\" data-toggle=\"tab\">Stream Monitor</a></li>\n  <li><a href=\"#file-transfer\" data-toggle=\"tab\">File Transfer</a></li>\n  <li><a href=\"#log\" data-toggle=\"tab\">Log</a></li>\n  <li class=\"pull-right\">\n      <button type=\"button\" id=\"sputnik-settings-restart\"\n                            class=\"btn btn-default btn-sm\"\n                            data-toggle=\"modal\"\n                            data-target=\"#sputnik-settings-just-restart-confirm\">\n        <span class=\"glyphicon glyphicon-repeat\"></span> Restart Sputnik\n    </button>\n</li>\n</ul>\n\n<!-- Tab panes -->\n<div class=\"tab-content\">\n  <div class=\"tab-pane active\" id=\"network\">\n    <form class=\"form-horizontal\">\n    <fieldset>\n    <legend>Sputnik Server</legend>\n\n    <div class=\"form-group\">\n      <label class=\"col-md-4 control-label\" for=\"textinput\">Inbound Port</label>\n      <div class=\"col-md-4\">\n      <input  name=\"input_port\" value=\"{{input_port}}\" type=\"number\" min=\"0\" class=\"form-control input-md\">\n      <span class=\"help-block\">The input port that Sputnik listens on for incoming connections from the Teradek Bond.</span>\n      </div>\n    </div>\n\n    <div class=\"form-group\">\n      <label class=\"col-md-4 control-label\" for=\"textinput\">Webserver Port</label>\n      <div class=\"col-md-4\">\n      <input  name=\"web_port\" value=\"{{web_port}}\" type=\"number\" min=\"0\" class=\"form-control input-md\">\n      <span class=\"help-block\">The port that Sputnik dashboard is presented on</span>\n      </div>\n    </div>\n\n    <div class=\"form-group\">\n      <label class=\"col-md-4 control-label\" for=\"textinput\">Database Port</label>\n      <div class=\"col-md-4\">\n      <input  name=\"redis_port\" value=\"{{redis_port}}\" type=\"number\" min=\"0\" class=\"form-control input-md\">\n      <span class=\"help-block\">The port that Sputnik database listens on</span>\n      </div>\n    </div>\n    </fieldset>\n    <div class=\"well\">\n        <div>\n        <button type=\"submit\" class=\"btn btn-primary\">Apply</button>\n        <button class=\"btn btn-default sputnik-settings-cancel\">Cancel</button>\n        </div>\n    </div>\n    </form>\n  </div>\n  <div class=\"tab-pane\" id=\"log\">\n    <form class=\"form-horizontal\">\n    <fieldset>\n    <legend>Log Files</legend>\n\n    <div class=\"form-group\">\n      <label class=\"col-md-4 control-label\" for=\"textinput\">Rotate when file exceeds (bytes)</label>\n      <div class=\"col-md-4\">\n      <span class=\"human_size\" style=\"position:absolute; color:gray; right:45px; top:10px;\"></span>\n      <input name=\"log_size\" value=\"{{log_size}}\" type=\"number\"  min=\"0\" class=\"form-control input-md\">\n      <span class=\"help-block\">Maximum size of server log file before rotation</span>\n      </div>\n    </div>\n\n    <div class=\"form-group\">\n      <label class=\"col-md-4 control-label\" for=\"textinput\">Number of Logs to Keep</label>\n      <div class=\"col-md-4\">\n      <input name=\"log_number\" value=\"{{log_number}}\" type=\"number\" min=\"0\" class=\"form-control input-md\">\n      <span class=\"help-block\">Maximum number of server log files before deleting oldest</span>\n      </div>\n    </div>\n    <div class=\"form-group\">\n        <div class=\"col-md-2\">\n\n        </div>\n        <div class=\"col-md-6\">\n            <div class=\"panel panel-default\">\n              <div class=\"panel-heading\">\n                <h3 class=\"panel-title\">Log File Status</h3>\n              </div>\n              <div class=\"panel-body\">\n                    <ul class=\"list-group\" id=\"sputnik-settings-log-file-status\" style=\"margin-bottom:10px;\">\n                        {{#each ../sputnik_log_files}}\n                            <li class=\"list-group-item\">\n                                <span>{{name}}</span>\n                                <span class=\"pull-right\" title=\"{{size}} bytes\">{{human_size}}</span>\n                            </li>\n                        {{/each}}\n                    </ul>\n\n\n\n                <div class=\"panel-group\" id=\"accordion\">\n                  <div class=\"panel panel-default\">\n                    <div class=\"panel-heading collapsed\" style=\"cursor:pointer;\"\n                                data-toggle=\"collapse\"\n                                data-parent=\"#accordion\"\n                                href=\"#sputnik-settings-log-other-logs\">\n                      <h4 class=\"panel-title\">\n                        <a>\n                          other logs...\n                        </a>\n                      </h4>\n                    </div>\n                    <div id=\"sputnik-settings-log-other-logs\" class=\"panel-collapse collapse\">\n                        <ul class=\"list-group\" id=\"sputnik-settings-log-file-status\">\n                            {{#each ../other_log_files}}\n                                <li class=\"list-group-item\"><span>{{name}}</span> <span class=\"pull-right\" title=\"{{size}} bytes\">{{human_size}}</span></li>\n                            {{/each}}\n                        </ul>\n                    </div>\n                  </div>\n                </div>\n                Total Size of All Logs: <span title=\"{{../total_log_size}} bytes\">{{../human_total_log_size}}</span>\n\n\n              </div>\n              <div style=\"margin:10px;\">\n              <button id=\"sputnik-settings-refresh-log-stats\" class=\"btn btn-sm btn-default\">\n                  <span class=\"glyphicon glyphicon-refresh\"></span> Refresh\n              </button>\n              <button id=\"sputnik-settings-download-logs\" class=\"btn btn-sm btn-default\" data-loading-text=\"Preparing Download...\">\n                  <span class=\"glyphicon glyphicon-download\"></span> Download Logs\n              </button>\n              <button id=\"sputnik-settings-purge-log\" class=\"btn btn-sm btn-default pull-right\">\n                  Purge Old Sputnik Logs\n              </button>\n              </div>\n            </div>\n        </div>\n    </div>\n\n    </fieldset>\n    <div class=\"well\">\n        <div>\n        <button type=\"submit\" class=\"btn btn-primary\">Apply</button>\n        <button class=\"btn btn-default sputnik-settings-cancel\">Cancel</button>\n        </div>\n    </div>\n    </form>\n  </div>\n  <div class=\"tab-pane\" id=\"stream-monitor\">\n    <form class=\"form-horizontal\">\n    <fieldset>\n    <legend>RTSP Server</legend>\n\n    <div class=\"form-group\">\n      <label class=\"col-md-4 control-label\" for=\"textinput\">Mode</label>\n        <div class=\"col-md-4\">\n          <label class=\"radio-inline\">\n            <input type=\"radio\" name=\"rtp_server\" id=\"optionsRadios1\" value=\"yes\" {{#rtp_server_enabled}}checked{{/rtp_server_enabled}}>\n            Enabled\n          </label>\n          <label class=\"radio-inline\">\n            <input type=\"radio\" name=\"rtp_server\" id=\"optionsRadios2\" value=\"no\" {{^rtp_server_enabled}}checked{{/rtp_server_enabled}}>\n            Disabled\n          </label>\n          <span class=\"help-block\">Enable/Disable automatically running an RTSP Server</span>\n      </div>\n    </div>\n\n    <div class=\"form-group\">\n      <label class=\"col-md-4 control-label\" for=\"textinput\">RTSP Port</label>\n      <div class=\"col-md-4\">\n      <input name=\"rtp_server_port\" value=\"{{rtp_server_port}}\" type=\"number\"  min=\"0\" class=\"form-control input-md\">\n      <span class=\"help-block\">The port the RTSP Server should run on. Default is 554</span>\n      </div>\n    </div>\n\n    <div class=\"form-group\">\n      <label class=\"col-md-4 control-label\" for=\"textinput\">Username</label>\n      <div class=\"col-md-4\">\n      <input name=\"rtp_server_username\" value=\"{{rtp_server_username}}\" type=\"text\" class=\"form-control input-md\">\n      <span class=\"help-block\">If username & password is set, users must authenticate to view the stream.</span>\n      </div>\n    </div>\n\n    <div class=\"form-group\">\n      <label class=\"col-md-4 control-label\" for=\"textinput\">Password</label>\n      <div class=\"col-md-4\">\n      <input name=\"rtp_server_password\" value=\"{{rtp_server_password}}\" type=\"password\" class=\"form-control input-md\">\n      <span class=\"help-block\">If username & password is set, users must authenticate to view the stream.</span>\n      </div>\n    </div>\n    </fieldset>\n\n    <div class=\"well\">\n        <div>\n        <button type=\"submit\" class=\"btn btn-primary\">Apply</button>\n        <button class=\"btn btn-default sputnik-settings-cancel\">Cancel</button>\n        </div>\n    </div>\n\n    </form>\n  </div>\n  <div class=\"tab-pane\" id=\"file-transfer\">\n    <form class=\"form-horizontal\">\n    <fieldset>\n    <legend>File Transfer</legend>\n\n        <div class=\"form-group\">\n          <label class=\"col-md-4 control-label\" for=\"textinput\">Upload Folder</label>\n          <div class=\"col-md-4\">\n          <input name=\"upload_path\" data-ogvalue=\"{{upload_path}}\" value=\"{{upload_path}}\" type=\"text\" class=\"form-control input-md\">\n          <span class=\"help-block\">Local folder to use for file transfers</span>\n          </div>\n        </div>\n\n    </fieldset>\n\n    <div class=\"well\">\n        <div>\n        <button type=\"submit\" class=\"btn btn-primary\">Apply</button>\n        <button class=\"btn btn-default sputnik-settings-cancel\">Cancel</button>\n        </div>\n    </div>\n\n    </form>\n  </div>\n\n</div>\n</div>\n{{/model}}\n\n<div id=\"sputnik-settings-restart-warning\" class=\"modal fade\">\n  <div class=\"modal-dialog\">\n    <div class=\"modal-content\">\n      <div class=\"modal-header\">\n        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-hidden=\"true\">&times;</button>\n        <h4 class=\"modal-title\">Restart Sputnik?</h4>\n      </div>\n      <div class=\"modal-body\">\n        <p>To apply your new settings, you must restart Sputnik.</p>\n        <p>Do you want to restart Sputnik?</p>\n      </div>\n      <div class=\"modal-footer\">\n        <button  type=\"button\" class=\"btn btn-default\" data-dismiss=\"modal\">Cancel</button>\n        <button id=\"sputnik-settings-save-button\" type=\"button\" class=\"btn btn-primary\">Restart</button>\n      </div>\n    </div><!-- /.modal-content -->\n  </div><!-- /.modal-dialog -->\n</div><!-- /.modal -->\n\n\n<div id=\"sputnik-settings-just-restart-confirm\" class=\"modal\">\n  <div class=\"modal-dialog\">\n    <div class=\"modal-content\">\n      <div class=\"modal-header\">\n        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-hidden=\"true\">&times;</button>\n        <h4 class=\"modal-title\">Restart Sputnik?</h4>\n      </div>\n      <div class=\"modal-body\">\n        <p>This will disrupt your streams.</p>\n        <p>Are you sure you want to restart Sputnik?</p>\n      </div>\n      <div class=\"modal-footer\">\n        <button  type=\"button\" class=\"btn btn-default\" data-dismiss=\"modal\">Cancel</button>\n        <button id=\"sputnik-restart-button\" type=\"button\" class=\"btn btn-primary\">Restart</button>\n      </div>\n    </div><!-- /.modal-content -->\n  </div><!-- /.modal-dialog -->\n</div><!-- /.modal -->\n\n\n\n<div class=\"modal fade\" id=\"sputnik-settings-restart-wait\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"Restarting\" aria-hidden=\"true\">\n  <div class=\"modal-dialog\">\n    <div class=\"modal-content\">\n      <div class=\"modal-body\">\n        Restarting...\n      </div>\n    </div>\n  </div>\n</div>\n\n');Application.View.extend({
  name: "sputnikConfig/index"
  ,initialize:function(){
      var _this = this;
      this.model.fetch({resetQueue: true, success:function(model, response, opts){
          _this.modelBackup = model.toJSON();
          _this.setupHumanFileSize();
        }
      });
      this.getLogStats();
  }
  ,setupTabs:function(){
     $('a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
        localforage.setItem('sputnik-settings-last-tab', $(e.target).attr('href'));
      });

      localforage.getItem('sputnik-settings-last-tab').then(function(lastTab){
          if( lastTab ){
              $('a[href="'+lastTab+'"]').tab('show');
          }
      });
  }
  ,getLogStats:function(){
      var _this = this;
      return $.ajax({url:'/sputnik/logs/files', dataType:'json'}).done(function(data){
          var filterFunc = function(v){
              if( v.name.match(/^sputnik.log$|^sputnik\.log\.[0-9]{8}-[0-9]{6}/) ){
                  return true;
              }
          };
          var total_size = 0;
          _.map( data, function(v){ v.human_size = filesize(parseInt(v.size)); total_size+=parseInt(v.size); });
          _this.sputnik_log_files = _.filter(data, filterFunc);
          _this.other_log_files   = _.reject(data, filterFunc);
          _this.total_log_size = total_size;
          _this.human_total_log_size = filesize(parseInt(total_size));
          _this.render();
      })
  }
  ,context:function(){
      var res = {};
      if( this.model.get('rtp_server') == 'yes' ){
            res.rtp_server_enabled = 'yes';
      }
      return res;
  }
  ,setupHumanFileSize:function(){
      var size = parseInt($('[name="log_size"]').val());
      if( size ){
          var $humanSize = $('.human_size', $('[name="log_size"]').parent());
          $humanSize.html(filesize(size));
      }
  }
  ,restart:function(){
      var web_port = this.model.get('web_port');
      $.ajax({'url':'/restart'}).done(function(){
          var newHost = window.location.protocol + '//'
                             + window.location.hostname + ':' + web_port + '/';

          setInterval(function(){
              $('body').append('<img src="'+newHost+'images/logo.png?_='+ new Date().getTime()+'" style="display:none;" onload="window.location = \''+newHost+'\'">');
           }, 1000);
      });
  }
  ,events:{
      "click #sputnik-settings-refresh-log-stats":function(event){
         event.preventDefault();
         $('#sputnik-settings-log-file-status li').fadeOut();
         this.getLogStats().done(function(){
             $('#sputnik-settings-log-file-status li').fadeIn();
         });

         return false;
      }
      ,"click #sputnik-settings-download-logs":function(event){
          event.preventDefault();
          var btn = $(event.target);
          btn.button('loading');
          if( $('#download-logs-iframe').length == 0 ){
              $('body').append('<iframe id="download-logs-iframe" style="display:none;"></iframe>');
          }
          $('#download-logs-iframe').attr('src', '/sputnik/logs/files?download');
          setTimeout(function(){
              btn.button('reset');
          }, 3000);
          return false;
      }
      ,"click #sputnik-settings-purge-log":function(event){
         event.preventDefault();
         var _this = this;
         $.ajax({url:'/sputnik/logs', type:'DELETE'}).done(function(){
             $('#sputnik-settings-refresh-log-stats').click();
         });
         return false;
      },
      "click [type=submit]":function(event){
          event.preventDefault();
          $('#sputnik-settings-restart-warning').modal('show');
      },
      "click #sputnik-settings-save-button": function(event) {
          event.preventDefault();

          var _this = this;
          var curSettings = this.serialize();
          var originalSettings =  _this.modelBackup;
          var changedSettings = {};
           _.each(curSettings, function(v, k){
              if( originalSettings[k] != v ){
                  changedSettings[k] = v;
              }
          })
          //console.log('changedsettings', changedSettings)
          this.model.save(changedSettings, {
              patch: true
              ,success:function(){
                  $('#sputnik-settings-restart-warning').modal('hide');
                  $('#sputnik-settings-restart-wait').modal('show');
                  _this.restart();
              }
              ,error:function(model, response, options){
                  try{
                  var errors = JSON.parse(response.responseText);
                  $('#sputnik-settings-restart-warning').modal('hide');
                  var source   = "<ul>{{#each errorMsgs}}<li>{{name}}: {{msg}}</li>{{/each}}</ul>";
                  var template = Handlebars.compile(source);
                  $('#error-display .erroMsg').html(template(errors));
                  $('#error-display').slideDown();
                  }
                  catch(e){
                      console.log(e);
                  }
              }
      });
      return false;
    }
    ,"click #sputnik-restart-button":function(){
        $('#sputnik-settings-just-restart-confirm').modal('hide');
        $('#sputnik-settings-restart-wait').modal('show');
        this.restart();
    }
    ,"click .sputnik-settings-cancel":function(event){
         event.preventDefault();
         _.each(this.modelBackup, function(v,k,l){ if(v == null){  l[k] = ""; } });
         $('input,select', this.el).hide();
         this.populate(this.modelBackup);
         $('input,select', this.el).fadeIn();
         $('[name="log_size"]').change();
         return false;
      }
    ,'change [name="log_size"]':function(e){
        this.setupHumanFileSize();
    }
    ,'keyup [name="log_size"]':function(e){
        this.setupHumanFileSize();
   }
    ,"rendered":function(){
        this.setupTabs();
    }
  }
});

// Instances of this view can be created by calling:
// new Application.Views["sputnikConfig/index"]()
;;
Handlebars.templates['sputnikConfig/userManagement'] = Handlebars.compile('<div style=\"max-width:500px;margin:20px auto auto auto\">\n{{#collection tag=\"ul\" class=\"list-group\"}}\n<li class=\"list-group-item row\">\n    <label class=\"col-sm-2 control-label\">\n        Username\n    </label>\n    <div class=\"col-sm-8\">\n           {{username}}\n    </div>\n    <div class=\"col-sm-2\">\n        <button class=\"btn btn-primary pull-right\" data-toggle=\"modal\" data-target=\"#edit-{{username}}\">\n          Edit\n        </button>\n    </div>\n</li>\n{{/collection}}\n</div>\n\n{{!--\n    using \"each\" instead of collection helper here because the boostrap modal dialog dismiss properly if\n    nested inside a div (which is necessary for the collection helper)\n--}}\n{{#each users}}\n<!-- Modal -->\n<div class=\"modal fade\" id=\"edit-{{this.username}}\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myModalLabel\" aria-hidden=\"true\">\n  <div class=\"modal-dialog\">\n    <div class=\"modal-content\">\n    <form class=\"form-horizontal\" role=\"form\">\n      <div class=\"modal-header\">\n        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-hidden=\"true\">&times;</button>\n        <h4 class=\"modal-title\" id=\"myModalLabel\">Edit \"{{this.username}}\"</h4>\n      </div>\n      <div class=\"modal-body\">\n          <div class=\"form-group\">\n             <input type=\"hidden\" name=\"id\" value=\"{{this.id}}\">\n            <label for=\"password-{{this.username}}\" class=\"col-sm-2 control-label\">Password</label>\n            <div class=\"col-sm-10\">\n              <input id=\"password-{{this.username}}\" type=\"password\" class=\"form-control\">\n            </div>\n          </div>\n          <div class=\"form-group\">\n            <label for=\"password-confirm-{{this.username}}\" class=\"col-sm-2 control-label\">Confirm Password</label>\n            <div class=\"col-sm-10\">\n              <input id=\"password-confirm-{{this.username}}\" type=\"password\" class=\"form-control\">\n            </div>\n          </div>\n          <div class=\"alert alert-success\" style=\"display:none;\">\n              <strong>Success!</strong> You successfully updated {{this.username}}\'s password.\n            </div>\n\n      </div>\n      <div class=\"modal-footer\">\n        <button type=\"button\" class=\"btn btn-default\" data-dismiss=\"modal\">Close</button>\n        <button type=\"submit\" class=\"btn btn-primary\">Save changes</button>\n      </div>\n    </form>\n    </div>\n  </div>\n</div>\n{{/each}}');Application.View.extend({
  name: "sputnikConfig/userManagement"
  ,initialize:function(){
      var _this = this;
      this.collection.fetch({resetQueue: true});

      this.collection.on('reset', function(){
         _this.render();
      })

  }
  ,context:function(){
      return {
            users: this.collection.toJSON()
        }
  }
  ,events:{
      "keyup":function(event){
          $('.alert-success').hide();
      }
      ,"submit form": function(event) {
          event.preventDefault();
          var id = $('[name=id]',event.target).val();
          var model = this.collection.get(id);
          var username = model.get('username');
          model.save({password:$('#password-'+username).val()},{
                success:function(data){
                    $('.alert-success',event.target).show();
                },
                error:function(){
                    console.log(arguments);
                    }
                });
    }
  }
});

// Instances of this view can be created by calling:
// new Application.Views["sputnikConfig/userManagement"]()
;;


  if (Application['sputnikConfig'] !== module.exports) {
    console.warn("Application['sputnikConfig'] internally differs from global");
  }
  return module.exports;
}).call(this);
