var fs = require('fs')
 ,exec = require('child_process').exec
 ,  _  = require('underscore')
  ,admZip = require('adm-zip')
 ,path = require('path');

module.exports = function(self, app, checkAdmin, config){

   app.get('/sputnik/logs/files', checkAdmin, function(req, res){
            var filepath = '/var/log/'
            var files = fs.readdirSync(filepath);

            var results = [];
            _.each(files, function(file){
                try{
                    if( file.match(/^sputnik.*\.log$|^sputnik.*\.log.[0-9]+$|^sputnik\.log\.[0-9]{8}-[0-9]{6}$/) ){
                        var stats = fs.statSync( filepath+file );
                         results.push({
                            name: file
                            ,size: stats.size
                            ,path:filepath+file
                        });
                    }
                }
                catch(e){
                    console.log(e);
                }
            });
           if( 'download' in req.query ){
               var zip = new admZip();
                _.each(results, function(file){
                    zip.addLocalFile(file.path);
                })
               var zipBuffer = zip.toBuffer();
               res.header("Content-Disposition", 'attachment; filename="sputnik-logs.zip"');
               res.header('Content-Type', 'application/zip');
               res.end(zipBuffer, 'binary');
           }
           else{
               res.json(results);
           }
   });

   app.delete('/sputnik/logs', checkAdmin, function(req, res){
        exec("rm -f /var/log/sputnik.log.* /var/log/sputnik-core.log.*", function(error, stdout, stderr){
            if (error) {
                console.log('failed to restart sputnik', error, stdout, stderr);
                res.json({error:true, stdout:stdout, stderr:stderr})
            }
            else{
                res.json({success:stdout})
            }
        });
   });
}