var _ = require('underscore'),
    previewPending = {};

var loadPlugins = function(sid){
    console.log('====Running plugin watchdog check====')
    var self = this;
    self.jobs.loadSnapshotPlugin(sid).finally(function(){
        if( self.config && self.config.rtp_server && self.config.rtp_server == 'yes' ){
            self.jobs.loadRTSPServerPlugin(sid, self.config);
        }
    });
}

var events = {

    open_session: function (sid, ifaces) {
        var self = this;

        /* --- Do not attach handlers again if this session is already open --- */
        if (this._sessions[sid] && this._sessions[sid][ifaces]){return;}

        this._sessions[sid]= (this._sessions[sid] || {});
        this._sessions[sid][ifaces] = 1;


        console.log('open_session()', sid, ifaces);
        /* --- Run jobs --- */

        this.socket.emit('send device:session', {sid: sid, status: 'online'});
        //this.jobs.updateUdptsPort(sid);   // не надо, т.к. если была пара то вещание прекратится
        this.socket.emit('cache,send device:settings', {sid: sid});
        this.socket.emit('update sputnik:inventory', {sid: sid, sessionStatus: 'online'});

        if( ifaces.search('E') != -1 ){
            loadPlugins.apply(self, [sid]);
            console.log('starting plugin watchdog');
            self.plugin_watchdog = setInterval(function(){loadPlugins.apply(self, [sid])}, 10000);

        }

/*        this.sess(sid).iface('C').enqueue('session:devType', function (session) {
            session.getDeviceType()(function (type) {
                console.log('Device type for', sid, 'is: ', type);
                if (type != 'encoder') return;

                //self.plugins.record(self, sid); // загружаем плагин записи

//                setTimeout(function () {
//                    self.socket.emit('device:record', {action: 'start', id: 'asdfawefq23r23r', encoder: {sid: sid}, upload: true});
//                }, 60000);
//                setTimeout(function () {
//                    self.socket.emit('device:record', {action: 'stop', id: 'asdfawefq23r23r', encoder: {sid: sid}, upload: true});
//                }, 70000);


                setTimeout(function doSnap() {
                    if (!self._sessions[sid]) {
                        previewPending[sid] = 0;
                        return;
                    }
                    if (previewPending[sid]) return setTimeout(doSnap, 100);
                    previewPending[sid] = 1;
                    self.socket.emit('send device:preview', {sid: sid, finish: function () {
                        previewPending[sid] = 0;
                    }});
                    setTimeout(doSnap, 1000);
                }, 5000);

            }, function (err) {
                console.error(err.stack || err.toString());
            });
        })

        /* --- Handle session events --- */
/*
        this.sess.events.on('sess:' + sid, function (ch, json) {
            if (ch.match(/.*:.*?E.*?:conn:(.*):modem_info$/i)) self.socket.emit('send dev:modems', {sid: sid, json: json});

            else if (ch.match(/.*:.*?E.*?:conn:(.*):stats$/i)) self.socket.emit('send device:ports', {sid: sid, json: json});

            else if (ch.match(/.*:.*?E.*?:stats$/i)) self.socket.emit('send device:stats', {sid: sid, json: json});

            else if (ch.match(/.*:.*?([EC]).*?$/i)) self.socket.emit('send device:event', {sid: sid, json: json});

        });*/
    },

    close_session: function (sid, ifaces) {
        if (!this._sessions[sid]) return;
        console.log('close_session()', sid, ifaces);
        if( 'plugin_watchdog' in this ){
            console.log('session closed so turning off plugin watchdog.');
            clearInterval(this.plugin_watchdog);
        }
		//plugins are automatically unloaded by sputnik
		//the pluginsMap will not be updated
        this.socket.emit('send device:session', {sid: sid, status: 'offline'});
        this.socket.emit('update sputnik:inventory', {sid: sid, sessionStatus: 'offline'});
        this.sess.events.removeAllListeners('sess:' + sid);
        delete this._sessions[sid][ifaces];

    }
}


module.exports = function (app) {
    _.each(events, function (handler, evtName) {
        app.sess.events.on(evtName, handler.bind(app));
    });

    app.on('tls:connected', function () {
        previewPending = {};
    });

}
