var  _         = require('underscore')
    ,session   = require('../lib/session')
    ,prototype = require('./prototype')
    ,jobs      = require('./jobs')
    ,plugins   = require('./plugins')
    ,events    = new (require('events').EventEmitter)


function App(config) {
    var self = this
    this.sess = session;
    this._sessions = {};


    /* --- Init session --- */
	this.sess.init();

    /* --- Add events to App instance --- */
    _.extend(this, events.__proto__);


    _.each(jobs, function (fn, key) {
        if (typeof fn === 'function') jobs[key] = fn.bind(self);
    });

    this.jobs = jobs;
    this.plugins = plugins;
    this.config = config;
    this.setupEvents();
    self.emit('app:created', config);
}

_.extend(App.prototype, prototype);

module.exports = App;