/*
 * Copyright, 2012, Teradek
 * 
 * All rights reserved.
 * Contact Teradek for licensing.
 */

var redis = require('redis'),
	util = require('util'),
	cli = require('Node-CLI/node-cli.js'),
	colors = require('colors.js');

var numLogLines = 24
var logStartRow = 30

var logColor = {
	0 : "red",
	1 : "yellow",
	2 : "green",
	3 : "default",
	4 : "blue",
	5 : "purple"
}

function show(dbconfig, server, row) {
	var db = redis.createClient(dbconfig.port, dbconfig.host)
	
	db.psubscribe("server:" + server + ":log");
	
	cli.move(logStartRow-1, 2).write("SERVER LOGS".bold.blue)

	db.on("pmessage", function(err, channel, message) {
		var logDB = redis.createClient(dbconfig.port, dbconfig.host)
		var key = "server:" + server + ":log:" + message;
		
		logDB.lrange(key, 0, numLogLines, function(err, logs) {
			for (var i = 0; i < numLogLines; i++) {
				var log
				var line
				
				if (logs[i]) {
					try {
						line = numLogLines - i
						log = JSON.parse(logs[i]);
						var timeStamp = new Date(log.ts*1000)
						cli.move(logStartRow+line, 0).clearLine()
						cli.move(logStartRow+line, 2).color("default")
							.write(timeStamp.toDateString() + " ")
							.write(timeStamp.toLocaleTimeString());
						cli.move(logStartRow+line, 28).color(logColor[log.level]).write(log.msg);
						cli.resetColor()
					} 
					catch (err) {
						cli.move(logStartRow+line, 0).clearLine()
					}
				}
			}
		});
	});
}

module.exports = {
	"show" : show
}